﻿package classes {
	import flash.display.Bitmap;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.text.Font;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.TextFormatAlign;
	import flash.text.AntiAliasType;
	import flash.events.MouseEvent;
	import com.hydrotik.go.HydroTween;
	import fl.motion.easing.*;
	import flash.utils.Timer;
	import flash.events.TimerEvent;
	
	import flash.text.TextFieldAutoSize;	public class Main extends Sprite {
		
		private var _font1:FontLoader;
		private var _bms:Array;
		private var _fl:Number = 250;
		private var _numPattern:Number = 0;
		private var _centerX:Number;
		private var _centerY:Number;
		private var _totalWidths:Array;
		private var _sentokun:Sentokun;
		private var _textContainer:Sprite;
		private var _speed:Number = 40;
		
		public function Main() {
			stage.scaleMode = "noScale";
			stage.align = "TL";
			
			_font1 = new FontLoader("font.swf");
			_font1.addEventListener(FontLoader.FONTLOADCOMPLETE , fontLoadeCompleteFunc ) ;
			_font1.load();
		
		}
		
		private function fontLoadeCompleteFunc(e:Event):void {
			_font1.registerFont("Font1");
			
			var tb:TextBitmap = new TextBitmap(  new _font1.Font1);
			_bms = tb.bms;

			stage.addEventListener( MouseEvent.CLICK , startClickHandler );
			
		}
		
		private function startClickHandler(e:MouseEvent):void {
			stage.removeEventListener( MouseEvent.CLICK , startClickHandler );
			
			_sentokun = new Sentokun();
			addChild(_sentokun);
			_sentokun.x = stage.stageWidth / 2;
			_sentokun.y = stage.stageHeight / 2;
			
			_sentokun.addEventListener( _sentokun.OPENING1_COMPLETE , open1CompHandler );
		}
		
		private function open1CompHandler(e:Event):void {
			_sentokun.removeEventListener( _sentokun.OPENING1_COMPLETE , open1CompHandler );
			
			_textContainer = new Sprite();
			addChild(_textContainer );
			
			_centerX = stage.stageWidth / 2;
			_centerY = stage.stageHeight / 2;
			_totalWidths = [];
			for (var ix:int = 0; ix < _bms.length; ix++) {
				var bms1:Array = _bms[ix];
				var totalWidth:Number = 0;
				for (var iy:int = 0; iy < bms1.length; iy++) {
					var sp:particleSprite = bms1[iy];
					sp.x = _centerX;
					sp.y = _centerY;
					sp.targetX = Math.random() * stage.stageWidth;
					sp.targetY = Math.random() * stage.stageHeight;
					sp.targetZ = Math.random() * 600 + 80;
					sp.z = 1000;
					totalWidth += sp.width + sp.space;
					var scale:Number = _fl / (_fl + sp.z );
					sp.scaleX = sp.scaleY = scale;
					_textContainer.addChild(sp);
				}
				
				_totalWidths.push( totalWidth );
			}
			
			stage.addEventListener( MouseEvent.CLICK , stageClick );
			addEventListener(Event.ENTER_FRAME , onEnterFlameHandler );
			
			_sentokun.scaleOut();
		}
		
		private function stageClick(e:MouseEvent):void {
			_speed = 10;
			for (var ix:int = 0; ix < _bms.length; ix++) {
				var bms1:Array = _bms[ix];
				var xPos:Number = 0;
				for (var iy:int = 0; iy < bms1.length; iy++) {
					var sp:particleSprite = bms1[iy];
					
					if ( ix == _numPattern ) {
						sp.targetZ = 0;
						var tempscale:Number = sp.scaleX;
						var scale:Number = _fl / (_fl + sp.targetZ );
						sp.scaleX  = scale;
						sp.targetX = stage.stageWidth / 2 - _totalWidths[ix]/2 + sp.width + xPos;
						xPos += sp.width + sp.space;
						sp.scaleX = tempscale;
						sp.targetY = stage.stageHeight/2;
						HydroTween.go( sp , {Glow_color:0x7fa81f, Glow_blurX:16, Glow_blurY:16, Glow_alpha:0.8, Glow_strength:3} , 1, 0 );
					} else {
						sp.targetX = Math.random() * stage.stageWidth;
						sp.targetY = Math.random() * stage.stageHeight;
						sp.targetZ = Math.random() * 600 + 80;
						HydroTween.go( sp , {Glow_color:0x000000, Glow_blurX:0, Glow_blurY:0, Glow_alpha:0, Glow_strength:0} , 0, 0 );
					}
					
				}
			}
			_numPattern++;
			
			if ( _numPattern > _bms.length ) {
				stage.removeEventListener( MouseEvent.CLICK , stageClick );
				_sentokun.scaleIn();
				_sentokun.addEventListener( _sentokun.CLOSE1_COMPLETE , close1CompHandler );
			}
		}
		
		private function close1CompHandler(e:Event):void {
			_centerX = stage.stageWidth / 2;
			_centerY = stage.stageHeight / 2;
			for (var ix:int = 0; ix < _bms.length; ix++) {
				var bms1:Array = _bms[ix];
				for (var iy:int = 0; iy < bms1.length; iy++) {
					var sp:particleSprite = bms1[iy];
					sp.targetX = _centerX;
					sp.targetY = _centerY;
					sp.targetZ = 1000;
				}
			}
			
			var time:Timer = new Timer(1500 , 1 );
			time.addEventListener( TimerEvent.TIMER_COMPLETE , close1TimeHandler );
			time.start();
		}
		
		private function close1TimeHandler(e:TimerEvent):void {
			e.target.removeEventListener( TimerEvent.TIMER_COMPLETE , close1TimeHandler );
			setChildIndex( _textContainer , 0 );
			_sentokun.mouseclose();
			
			_sentokun.addEventListener( _sentokun.CLOSE2_COMPLETE , close2CompHandler );
			
		}
		
		private function close2CompHandler(e:Event):void {
			removeChild( _textContainer );
		}
		
		private function onEnterFlameHandler(e:Event):void {
			var temp:Array = [];
			
			for (var ix:int = 0; ix < _bms.length; ix++) {
				var bms1:Array = _bms[ix];
				for (var iy:int = 0; iy < bms1.length; iy++) {
					var sp:particleSprite = bms1[iy];
					sp.x += ( sp.targetX - sp.x ) / _speed;
					sp.y += ( sp.targetY - sp.y ) / _speed;
					sp.z += ( sp.targetZ - sp.z ) / _speed;
					var scale:Number = _fl / (_fl + sp.z );
					sp.scaleX = sp.scaleY = scale;
					sp.alpha = scale;
					temp.push(sp);
				}
			}
			
			temp.sortOn( "z" , Array.DESCENDING | Array.NUMERIC );
			for (var i:int = 0; i < temp.length; i++) {
				sp = temp[i];
				_textContainer.setChildIndex( sp , i );
			}
		}

		
	}
	
}